
!function(xhr) {
	var authorization, pollOpen

	xhr.get = function(url, next) {
		return makeReq("GET", url, null, next)
	}

	xhr.del = function(url, next) {
		return makeReq("DELETE", url, null, next)
	}

	xhr.post = function(url, data, next) {
		return makeReq("POST", url, data, next)
	}

	xhr.patch = function(url, data, next) {
		return makeReq("PATCH", url, data, next)
	}

	xhr.login = function(data, next) {
		makeReq(data ? "POST" : "GET", "/hello", data, function(err, json) {
			authorization = !err && json.authorization
			pollOpen = !!authorization
			if (next) {
				next(err, json)
			}
			setTimeout(longPoll, 1500)
		})
	}

	xhr.logout = function() {
		xhr.del("/hello", function(err, json) {
			authorization = null
			location.reload( false )
		})
	}

	xhr.makeReq = makeReq

	function makeReq(method, url, data, next) {
		var req = xhr(method, url, function(err, txt) {
			if (err == 401) {
				return Mediator.emit("login-fail")
			}
			// if Content-Type == "application/json"
			if (next) {
				next(err || !txt, !err && txt && this.status != 201 && JSON.parse(txt), req)
			}
		})
		if (authorization) {
			req.setRequestHeader("Authorization", authorization)
		}
		req.setRequestHeader("Content-Type", "application/json")
		req.send(data ? JSON.stringify(data) : null)
		return req
	}

	function name(key, val) {
		var nameData

		try {
			nameData = JSON.parse(window.name)
		} catch(e) {}

		if (!nameData || nameData.constructor !== Object) {
			nameData = {}
		}

		if (arguments.length > 1) {
			nameData[key] = val
			window.name = JSON.stringify(nameData)
		}
		return nameData[key]
	}

	function longPoll() {
		if (pollOpen) {
			var tab = name("tab") || name("tab", Math.random().toString(36).slice(2))
			xhr.post("/events", {tab: tab}, pollHandler)
		}
	}

	function pollHandler(err, res) {
		var i = 0
		, events = !err && (Array.isArray(res) ? res : res.events)
		, len = events && events.length || 0

		if (len) for (; i < len; ) {
			Mediator.emit("event", events[i++])
		}


		setTimeout(longPoll, err ? 6000 : 600)
	}

	xhr._logErrors = function(arr) {
		xhr("POST", "/errlog").send(arr.join("\n\n"))
	}
}(xhr)

